<template>
  <div>
    <!-- Generate CSS from types and tags -->
    <!-- Avoids any state in labels -->
    <css-injector
      v-for="generator, index in generators"
      :key="index"
      :generator="generator"
    />
    <div />
  </div>
</template>
<script lang="ts">
import {
  Vue, Component,
} from 'vue-property-decorator';
import CssInjector from '@/components/canvas-addons/CssInjector.vue';

import type { CssGenerator } from '@/logic/CSSGenerator';
import { syncTypes } from '@/synchronization-logic/SynchronizationTypes';
import { TagColorGenerator } from '@/logic/TagColorGenerator';
import { FilterStyleGenerator } from '@/logic/FilterStyleGenerator';

/**
 * The main dezrann integration
 *
 * Displays a piece analysis and lets a user modify it
 */
@Component({
  components: {
    CssInjector,
  },
})
export default class SyncColorGenerator extends Vue {
  // Main states

  colorGenerator = new TagColorGenerator();

  generators: CssGenerator[] = [];

  mounted() {
    this.colorGenerator = new TagColorGenerator();
    this.generators = [
      new FilterStyleGenerator(syncTypes),
      this.colorGenerator,
    ];
    const numbers = Array.from({ length: 300 }, (v, k) => k.toString());
    this.colorGenerator.updateUsedColors(numbers);
  }
}

</script>
